function phpblock_slimserver () {

global $_CONF;

// Configure your Slimserver here...
$slimserver = '192.168.2.40';
$slimport = '9000';
$slimxmlfile = 'http://' . $slimserver.':'. $slimport . '/xml/status.xml';

// Path for the xml/xsl files
$xmlpath = $_CONF['path_html'] . 'slimserver';
// Name of status.xml file
$xmlfile = $xmlpath . '/status.xml';

// Blurb on Squeezebox
$retval .= "I listen to music through the Squeezebox, a device made by <a href=\"http://www.slimdevices.com\" target=_new>SlimDevices</a> that plays MP3s you have on your computer through your stereo system.<P>";

//DON'T CHANGE ANYTHING BELOW
// Grab the status.xml page from the Slimserver
$fp = fopen($slimxmlfile, "r");

if ($fp) {
  //echo "Connection established.";

  /* We set the timeout here */
  $start = time();
  socket_set_timeout($fp,2);
  socket_set_blocking($fp,FALSE);
  $buffer = '';
  while (!feof($fp)) {
      $buffer .= fgets($fp,4096);
  }
  /* Close connection */
  fclose($fp);
  //echo $buffer;
}

// Write the status.xml file for transformation
$fp = fopen($xmlfile, "w+");

if ($fp) {
  //echo "Connection established.";
  fputs($fp, $buffer);
  fclose($fp);
}

if (file_exists($xmlfile)) {

        // Make sure status.xml is not empty
	$size = filesize($xmlfile);

	if ($size > 0) {
		// Create an XSLT processor
		$xsltproc = xslt_create();
		// Perform the transformation
		$html = xslt_process($xsltproc, $xmlpath. '/status.xml', $xmlpath . '/slimserver.xsl');

			// Detect errors
			if (!$html) {
				$retval .= 'XSLT processing error: '.xslt_error($xsltproc);
			} else {
				// Destroy the XSLT processor
				xslt_free($xsltproc);
				// Output the resulting HTML
				$retval .= $html;
			}
	} else {
		// Slimserver not playing
		$retval .= "I'm not currently listening to any music.";
	}
}

return $retval;
}